<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_201) on Tue Jun 11 21:47:07 AEST 2019 -->
<title>CommandsManager (worldedit-core 7.0.0 API)</title>
<meta name="date" content="2019-06-11">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="CommandsManager (worldedit-core 7.0.0 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":42,"i1":42,"i2":42,"i3":42,"i4":42,"i5":42,"i6":42,"i7":42,"i8":42,"i9":42,"i10":42,"i11":42,"i12":42,"i13":38,"i14":42,"i15":42,"i16":42,"i17":42,"i18":42};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],8:["t4","Concrete Methods"],32:["t6","Deprecated Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../com/sk89q/minecraft/util/commands/CommandPermissionsException.html" title="class in com.sk89q.minecraft.util.commands"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../com/sk89q/minecraft/util/commands/CommandUsageException.html" title="class in com.sk89q.minecraft.util.commands"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/minecraft/util/commands/CommandsManager.html" target="_top">Frames</a></li>
<li><a href="CommandsManager.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.sk89q.minecraft.util.commands</div>
<h2 title="Class CommandsManager" class="title">Class CommandsManager&lt;T&gt;</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>com.sk89q.minecraft.util.commands.CommandsManager&lt;T&gt;</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - command sender class</dd>
</dl>
<hr>
<div class="block"><span class="deprecatedLabel">Deprecated.</span></div>
<br>
<pre>@Deprecated
public abstract class <span class="typeNameLabel">CommandsManager&lt;T&gt;</span>
extends java.lang.Object</pre>
<div class="block">Manager for handling commands. This allows you to easily process commands,
 including nested commands, by correctly annotating methods of a class.

 <p>To use this, it is merely a matter of registering classes containing
 the commands (as methods with the proper annotations) with the
 manager. When you want to process a command, use one of the
 <code>execute</code> methods. If something is wrong, such as incorrect
 usage, insufficient permissions, or a missing command altogether, an
 exception will be raised for upstream handling.</p>

 <p>Methods of a class to be registered can be static, but if an injector
 is registered with the class, the instances of the command classes
 will be created automatically and methods will be called non-statically.</p>

 <p>To mark a method as a command, use <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands"><code>Command</code></a>. For nested commands,
 see <a href="../../../../../com/sk89q/minecraft/util/commands/NestedCommand.html" title="annotation in com.sk89q.minecraft.util.commands"><code>NestedCommand</code></a>. To handle permissions, use
 <a href="../../../../../com/sk89q/minecraft/util/commands/CommandPermissions.html" title="annotation in com.sk89q.minecraft.util.commands"><code>CommandPermissions</code></a>.</p>

 <p>This uses Java reflection extensively, but to reduce the overhead of
 reflection, command lookups are completely cached on registration. This
 allows for fast command handling. Method invocation still has to be done
 with reflection, but this is quite fast in that of itself.</p></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.Map&lt;java.lang.reflect.Method,java.util.Map&lt;java.lang.String,java.lang.reflect.Method&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#commands">commands</a></span></code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Mapping of commands (including aliases) with a description.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.util.Map&lt;java.lang.String,java.lang.String&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#descs">descs</a></span></code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Mapping of commands (not including aliases) with a description.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.Map&lt;java.lang.String,java.lang.String&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#helpMessages">helpMessages</a></span></code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Mapping of commands (not including aliases) with a description.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected <a href="../../../../../com/sk89q/minecraft/util/commands/Injector.html" title="interface in com.sk89q.minecraft.util.commands">Injector</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#injector">injector</a></span></code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Stores the injector used to getInstance.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.Map&lt;java.lang.reflect.Method,java.lang.Object&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#instances">instances</a></span></code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Used to store the instances associated with a method.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected static org.slf4j.Logger</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#logger">logger</a></span></code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#CommandsManager--">CommandsManager</a></span>()</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t6" class="tableTab"><span><a href="javascript:show(32);">Deprecated Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#checkPermission-T-java.lang.reflect.Method-">checkPermission</a></span>(<a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
               java.lang.reflect.Method&nbsp;method)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
&nbsp;</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#execute-java.lang.String:A-T-java.lang.Object...-">execute</a></span>(java.lang.String[]&nbsp;args,
       <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
       java.lang.Object...&nbsp;methodArgs)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Attempt to execute a command.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#execute-java.lang.String-java.lang.String:A-T-java.lang.Object...-">execute</a></span>(java.lang.String&nbsp;cmd,
       java.lang.String[]&nbsp;args,
       <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
       java.lang.Object...&nbsp;methodArgs)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Attempt to execute a command.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#executeMethod-java.lang.reflect.Method-java.lang.String:A-T-java.lang.Object:A-int-">executeMethod</a></span>(java.lang.reflect.Method&nbsp;parent,
             java.lang.String[]&nbsp;args,
             <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
             java.lang.Object[]&nbsp;methodArgs,
             int&nbsp;level)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Attempt to execute a command.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>protected java.lang.CharSequence</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#getArguments-com.sk89q.minecraft.util.commands.Command-">getArguments</a></span>(<a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&nbsp;cmd)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
&nbsp;</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.String,java.lang.String&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#getCommands--">getCommands</a></span>()</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get a list of command descriptions.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.String,java.lang.String&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#getHelpMessages--">getHelpMessages</a></span>()</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get a map from command name to help message.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code><a href="../../../../../com/sk89q/minecraft/util/commands/Injector.html" title="interface in com.sk89q.minecraft.util.commands">Injector</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#getInjector--">getInjector</a></span>()</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the injector used to create new instances.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>java.util.Map&lt;java.lang.reflect.Method,java.util.Map&lt;java.lang.String,java.lang.reflect.Method&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#getMethods--">getMethods</a></span>()</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the mapping of methods under a parent command.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>protected java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#getNestedUsage-java.lang.String:A-int-java.lang.reflect.Method-T-">getNestedUsage</a></span>(java.lang.String[]&nbsp;args,
              int&nbsp;level,
              java.lang.reflect.Method&nbsp;method,
              <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the usage string for a nested command.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>protected java.lang.String</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#getUsage-java.lang.String:A-int-com.sk89q.minecraft.util.commands.Command-">getUsage</a></span>(java.lang.String[]&nbsp;args,
        int&nbsp;level,
        <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&nbsp;cmd)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the usage string for a command.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#hasCommand-java.lang.String-">hasCommand</a></span>(java.lang.String&nbsp;command)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Checks to see whether there is a command named such at the root level.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>protected boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#hasPermission-java.lang.reflect.Method-T-">hasPermission</a></span>(java.lang.reflect.Method&nbsp;method,
             <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Returns whether a player has access to a command.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>abstract boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#hasPermission-T-java.lang.String-">hasPermission</a></span>(<a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
             java.lang.String&nbsp;permission)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Returns whether a player permission..</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#invokeMethod-java.lang.reflect.Method-java.lang.String:A-T-java.lang.reflect.Method-java.lang.Object-java.lang.Object:A-int-">invokeMethod</a></span>(java.lang.reflect.Method&nbsp;parent,
            java.lang.String[]&nbsp;args,
            <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
            java.lang.reflect.Method&nbsp;method,
            java.lang.Object&nbsp;instance,
            java.lang.Object[]&nbsp;methodArgs,
            int&nbsp;level)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
&nbsp;</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#register-java.lang.Class-">register</a></span>(java.lang.Class&lt;?&gt;&nbsp;cls)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Register an class that contains commands (denoted by <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands"><code>Command</code></a>.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>java.util.List&lt;<a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#registerAndReturn-java.lang.Class-">registerAndReturn</a></span>(java.lang.Class&lt;?&gt;&nbsp;cls)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Register an class that contains commands (denoted by <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands"><code>Command</code></a>.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>java.util.List&lt;<a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#registerMethods-java.lang.Class-java.lang.reflect.Method-">registerMethods</a></span>(java.lang.Class&lt;?&gt;&nbsp;cls,
               java.lang.reflect.Method&nbsp;parent)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Register the methods of a class.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html#setInjector-com.sk89q.minecraft.util.commands.Injector-">setInjector</a></span>(<a href="../../../../../com/sk89q/minecraft/util/commands/Injector.html" title="interface in com.sk89q.minecraft.util.commands">Injector</a>&nbsp;injector)</code>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Set the injector for creating new instances.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="logger">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>logger</h4>
<pre>protected static final&nbsp;org.slf4j.Logger logger</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
</li>
</ul>
<a name="commands">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>commands</h4>
<pre>protected&nbsp;java.util.Map&lt;java.lang.reflect.Method,java.util.Map&lt;java.lang.String,java.lang.reflect.Method&gt;&gt; commands</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Mapping of commands (including aliases) with a description. Root
 commands are stored under a key of null, whereas child commands are
 cached under their respective <code>Method</code>. The child map has
 the key of the command name (one for each alias) with the
 method.</div>
</li>
</ul>
<a name="instances">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>instances</h4>
<pre>protected&nbsp;java.util.Map&lt;java.lang.reflect.Method,java.lang.Object&gt; instances</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Used to store the instances associated with a method.</div>
</li>
</ul>
<a name="descs">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>descs</h4>
<pre>protected&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt; descs</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Mapping of commands (not including aliases) with a description. This
 is only for top level commands.</div>
</li>
</ul>
<a name="injector">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>injector</h4>
<pre>protected&nbsp;<a href="../../../../../com/sk89q/minecraft/util/commands/Injector.html" title="interface in com.sk89q.minecraft.util.commands">Injector</a> injector</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Stores the injector used to getInstance.</div>
</li>
</ul>
<a name="helpMessages">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>helpMessages</h4>
<pre>protected&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt; helpMessages</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Mapping of commands (not including aliases) with a description. This
 is only for top level commands.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="CommandsManager--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>CommandsManager</h4>
<pre>public&nbsp;CommandsManager()</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="register-java.lang.Class-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>register</h4>
<pre>public&nbsp;void&nbsp;register(java.lang.Class&lt;?&gt;&nbsp;cls)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Register an class that contains commands (denoted by <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands"><code>Command</code></a>.
 If no dependency injector is specified, then the methods of the
 class will be registered to be called statically. Otherwise, new
 instances will be created of the command classes and methods will
 not be called statically.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cls</code> - the class to register</dd>
</dl>
</li>
</ul>
<a name="registerAndReturn-java.lang.Class-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>registerAndReturn</h4>
<pre>public&nbsp;java.util.List&lt;<a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&gt;&nbsp;registerAndReturn(java.lang.Class&lt;?&gt;&nbsp;cls)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Register an class that contains commands (denoted by <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands"><code>Command</code></a>.
 If no dependency injector is specified, then the methods of the
 class will be registered to be called statically. Otherwise, new
 instances will be created of the command classes and methods will
 not be called statically. A List of <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands"><code>Command</code></a> annotations from
 registered commands is returned.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cls</code> - the class to register</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A List of <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands"><code>Command</code></a> annotations from registered commands,
 for use in eg. a dynamic command registration system.</dd>
</dl>
</li>
</ul>
<a name="registerMethods-java.lang.Class-java.lang.reflect.Method-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>registerMethods</h4>
<pre>public&nbsp;java.util.List&lt;<a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&gt;&nbsp;registerMethods(java.lang.Class&lt;?&gt;&nbsp;cls,
                                               java.lang.reflect.Method&nbsp;parent)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Register the methods of a class. This will automatically construct
 instances as necessary.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cls</code> - the class to register</dd>
<dd><code>parent</code> - the parent method</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Commands Registered</dd>
</dl>
</li>
</ul>
<a name="hasCommand-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasCommand</h4>
<pre>public&nbsp;boolean&nbsp;hasCommand(java.lang.String&nbsp;command)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Checks to see whether there is a command named such at the root level.
 This will check aliases as well.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>command</code> - the command</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the command exists</dd>
</dl>
</li>
</ul>
<a name="getCommands--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getCommands</h4>
<pre>public&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;getCommands()</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get a list of command descriptions. This is only for root commands.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a map of commands</dd>
</dl>
</li>
</ul>
<a name="getMethods--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMethods</h4>
<pre>public&nbsp;java.util.Map&lt;java.lang.reflect.Method,java.util.Map&lt;java.lang.String,java.lang.reflect.Method&gt;&gt;&nbsp;getMethods()</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the mapping of methods under a parent command.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the mapping</dd>
</dl>
</li>
</ul>
<a name="getHelpMessages--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getHelpMessages</h4>
<pre>public&nbsp;java.util.Map&lt;java.lang.String,java.lang.String&gt;&nbsp;getHelpMessages()</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get a map from command name to help message. This is only for root commands.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a map of help messages for each command</dd>
</dl>
</li>
</ul>
<a name="getUsage-java.lang.String:A-int-com.sk89q.minecraft.util.commands.Command-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getUsage</h4>
<pre>protected&nbsp;java.lang.String&nbsp;getUsage(java.lang.String[]&nbsp;args,
                                    int&nbsp;level,
                                    <a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&nbsp;cmd)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the usage string for a command.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>args</code> - the arguments</dd>
<dd><code>level</code> - the depth of the command</dd>
<dd><code>cmd</code> - the command annotation</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the usage string</dd>
</dl>
</li>
</ul>
<a name="getArguments-com.sk89q.minecraft.util.commands.Command-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getArguments</h4>
<pre>protected&nbsp;java.lang.CharSequence&nbsp;getArguments(<a href="../../../../../com/sk89q/minecraft/util/commands/Command.html" title="annotation in com.sk89q.minecraft.util.commands">Command</a>&nbsp;cmd)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
</li>
</ul>
<a name="getNestedUsage-java.lang.String:A-int-java.lang.reflect.Method-java.lang.Object-">
<!--   -->
</a><a name="getNestedUsage-java.lang.String:A-int-java.lang.reflect.Method-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNestedUsage</h4>
<pre>protected&nbsp;java.lang.String&nbsp;getNestedUsage(java.lang.String[]&nbsp;args,
                                          int&nbsp;level,
                                          java.lang.reflect.Method&nbsp;method,
                                          <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player)
                                   throws <a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the usage string for a nested command.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>args</code> - the arguments</dd>
<dd><code>level</code> - the depth of the command</dd>
<dd><code>method</code> - the parent method</dd>
<dd><code>player</code> - the player</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the usage string</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></code> - on some error</dd>
</dl>
</li>
</ul>
<a name="execute-java.lang.String-java.lang.String:A-java.lang.Object-java.lang.Object:A-">
<!--   -->
</a><a name="execute-java.lang.String-java.lang.String:A-T-java.lang.Object...-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>execute</h4>
<pre>public&nbsp;void&nbsp;execute(java.lang.String&nbsp;cmd,
                    java.lang.String[]&nbsp;args,
                    <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
                    java.lang.Object...&nbsp;methodArgs)
             throws <a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Attempt to execute a command. This version takes a separate command
 name (for the root command) and then a list of following arguments.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cmd</code> - command to run</dd>
<dd><code>args</code> - arguments</dd>
<dd><code>player</code> - command source</dd>
<dd><code>methodArgs</code> - method arguments</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></code> - thrown when the command throws an error</dd>
</dl>
</li>
</ul>
<a name="execute-java.lang.String:A-java.lang.Object-java.lang.Object:A-">
<!--   -->
</a><a name="execute-java.lang.String:A-T-java.lang.Object...-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>execute</h4>
<pre>public&nbsp;void&nbsp;execute(java.lang.String[]&nbsp;args,
                    <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
                    java.lang.Object...&nbsp;methodArgs)
             throws <a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Attempt to execute a command.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>args</code> - the arguments</dd>
<dd><code>player</code> - the player</dd>
<dd><code>methodArgs</code> - the arguments for the method</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></code> - thrown on command error</dd>
</dl>
</li>
</ul>
<a name="executeMethod-java.lang.reflect.Method-java.lang.String:A-java.lang.Object-java.lang.Object:A-int-">
<!--   -->
</a><a name="executeMethod-java.lang.reflect.Method-java.lang.String:A-T-java.lang.Object:A-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>executeMethod</h4>
<pre>public&nbsp;void&nbsp;executeMethod(java.lang.reflect.Method&nbsp;parent,
                          java.lang.String[]&nbsp;args,
                          <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
                          java.lang.Object[]&nbsp;methodArgs,
                          int&nbsp;level)
                   throws <a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Attempt to execute a command.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parent</code> - the parent method</dd>
<dd><code>args</code> - an array of arguments</dd>
<dd><code>player</code> - the player</dd>
<dd><code>methodArgs</code> - the array of method arguments</dd>
<dd><code>level</code> - the depth of the command</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></code> - thrown on a command error</dd>
</dl>
</li>
</ul>
<a name="checkPermission-java.lang.Object-java.lang.reflect.Method-">
<!--   -->
</a><a name="checkPermission-T-java.lang.reflect.Method-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkPermission</h4>
<pre>protected&nbsp;void&nbsp;checkPermission(<a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
                               java.lang.reflect.Method&nbsp;method)
                        throws <a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></code></dd>
</dl>
</li>
</ul>
<a name="invokeMethod-java.lang.reflect.Method-java.lang.String:A-java.lang.Object-java.lang.reflect.Method-java.lang.Object-java.lang.Object:A-int-">
<!--   -->
</a><a name="invokeMethod-java.lang.reflect.Method-java.lang.String:A-T-java.lang.reflect.Method-java.lang.Object-java.lang.Object:A-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>invokeMethod</h4>
<pre>public&nbsp;void&nbsp;invokeMethod(java.lang.reflect.Method&nbsp;parent,
                         java.lang.String[]&nbsp;args,
                         <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
                         java.lang.reflect.Method&nbsp;method,
                         java.lang.Object&nbsp;instance,
                         java.lang.Object[]&nbsp;methodArgs,
                         int&nbsp;level)
                  throws <a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="../../../../../com/sk89q/minecraft/util/commands/CommandException.html" title="class in com.sk89q.minecraft.util.commands">CommandException</a></code></dd>
</dl>
</li>
</ul>
<a name="hasPermission-java.lang.reflect.Method-java.lang.Object-">
<!--   -->
</a><a name="hasPermission-java.lang.reflect.Method-T-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasPermission</h4>
<pre>protected&nbsp;boolean&nbsp;hasPermission(java.lang.reflect.Method&nbsp;method,
                                <a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Returns whether a player has access to a command.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>method</code> - the method</dd>
<dd><code>player</code> - the player</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if permission is granted</dd>
</dl>
</li>
</ul>
<a name="hasPermission-java.lang.Object-java.lang.String-">
<!--   -->
</a><a name="hasPermission-T-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasPermission</h4>
<pre>public abstract&nbsp;boolean&nbsp;hasPermission(<a href="../../../../../com/sk89q/minecraft/util/commands/CommandsManager.html" title="type parameter in CommandsManager">T</a>&nbsp;player,
                                      java.lang.String&nbsp;permission)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Returns whether a player permission..</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>player</code> - the player</dd>
<dd><code>permission</code> - the permission</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if permission is granted</dd>
</dl>
</li>
</ul>
<a name="getInjector--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInjector</h4>
<pre>public&nbsp;<a href="../../../../../com/sk89q/minecraft/util/commands/Injector.html" title="interface in com.sk89q.minecraft.util.commands">Injector</a>&nbsp;getInjector()</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Get the injector used to create new instances. This can be
 null, in which case only classes will be registered statically.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>an injector instance</dd>
</dl>
</li>
</ul>
<a name="setInjector-com.sk89q.minecraft.util.commands.Injector-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setInjector</h4>
<pre>public&nbsp;void&nbsp;setInjector(<a href="../../../../../com/sk89q/minecraft/util/commands/Injector.html" title="interface in com.sk89q.minecraft.util.commands">Injector</a>&nbsp;injector)</pre>
<div class="block"><span class="deprecatedLabel">Deprecated.</span>&nbsp;</div>
<div class="block">Set the injector for creating new instances.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>injector</code> - injector or null</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../com/sk89q/minecraft/util/commands/CommandPermissionsException.html" title="class in com.sk89q.minecraft.util.commands"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../com/sk89q/minecraft/util/commands/CommandUsageException.html" title="class in com.sk89q.minecraft.util.commands"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?com/sk89q/minecraft/util/commands/CommandsManager.html" target="_top">Frames</a></li>
<li><a href="CommandsManager.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
